Index: /pykota/trunk/bin/dumpykota
===================================================================
--- /pykota/trunk/bin/dumpykota (revision 1720)
+++ /pykota/trunk/bin/dumpykota (revision 1724)
@@ -24,4 +24,7 @@
 #
 # $Log$
+# Revision 1.6  2004/09/15 18:28:41  jalet
+# Updated help for dumpykota
+#
 # Revision 1.5  2004/09/15 07:38:05  jalet
 # Fix for uninitialized variable
@@ -73,6 +76,6 @@
                          - groups : dumps user groups.
                          - printers : dump printers.
-                         - uquotas : dump user quotas.
-                         - gquotas : dump user groups quotas.
+                         - upquotas : dump user quotas.
+                         - gpquotas : dump user groups quotas.
                          - payments : dumps user payments.
                          - pmembers : dumps printer groups members.
Index: /pykota/trunk/man/edpykota.1
===================================================================
--- /pykota/trunk/man/edpykota.1 (revision 1722)
+++ /pykota/trunk/man/edpykota.1 (revision 1724)
@@ -2,7 +2,7 @@
 .TH EDPYKOTA "1" "September 2004" "C@LL - Conseil Internet & Logiciels Libres" "User Commands"
 .SH NAME
-edpykota \- manual page for edpykota 1.20alpha11_unofficial
+edpykota \- manual page for edpykota 1.20alpha12_unofficial
 .SH DESCRIPTION
-edpykota v1.20alpha11_unofficial (c) 2003-2004 C@LL - Conseil Internet & Logiciels Libres
+edpykota v1.20alpha12_unofficial (c) 2003-2004 C@LL - Conseil Internet & Logiciels Libres
 A Print Quota editor for PyKota.
 .PP
Index: /pykota/trunk/man/pkprinters.1
===================================================================
--- /pykota/trunk/man/pkprinters.1 (revision 1722)
+++ /pykota/trunk/man/pkprinters.1 (revision 1724)
@@ -2,7 +2,7 @@
 .TH PKPRINTERS "1" "September 2004" "C@LL - Conseil Internet & Logiciels Libres" "User Commands"
 .SH NAME
-pkprinters \- manual page for pkprinters 1.20alpha11_unofficial
+pkprinters \- manual page for pkprinters 1.20alpha12_unofficial
 .SH DESCRIPTION
-pkprinters v1.20alpha11_unofficial (c) 2003-2004 C@LL - Conseil Internet & Logiciels Libres
+pkprinters v1.20alpha12_unofficial (c) 2003-2004 C@LL - Conseil Internet & Logiciels Libres
 A Printers Manager for PyKota.
 .PP
Index: /pykota/trunk/man/pykotme.1
===================================================================
--- /pykota/trunk/man/pykotme.1 (revision 1722)
+++ /pykota/trunk/man/pykotme.1 (revision 1724)
@@ -2,7 +2,7 @@
 .TH PYKOTME "1" "September 2004" "C@LL - Conseil Internet & Logiciels Libres" "User Commands"
 .SH NAME
-pykotme \- manual page for pykotme 1.20alpha11_unofficial
+pykotme \- manual page for pykotme 1.20alpha12_unofficial
 .SH DESCRIPTION
-pykotme v1.20alpha11_unofficial (c) 2003-2004 C@LL - Conseil Internet & Logiciels Libres
+pykotme v1.20alpha12_unofficial (c) 2003-2004 C@LL - Conseil Internet & Logiciels Libres
 .PP
 Gives print quotes to users.
Index: /pykota/trunk/man/pykosd.1
===================================================================
--- /pykota/trunk/man/pykosd.1 (revision 1722)
+++ /pykota/trunk/man/pykosd.1 (revision 1724)
@@ -2,7 +2,7 @@
 .TH PYKOSD "1" "September 2004" "C@LL - Conseil Internet & Logiciels Libres" "User Commands"
 .SH NAME
-pykosd \- manual page for pykosd 1.20alpha11_unofficial
+pykosd \- manual page for pykosd 1.20alpha12_unofficial
 .SH DESCRIPTION
-pykosd v1.20alpha11_unofficial (c) 2003-2004 C@LL - Conseil Internet & Logiciels Libres
+pykosd v1.20alpha12_unofficial (c) 2003-2004 C@LL - Conseil Internet & Logiciels Libres
 An OSD quota monitor for PyKota.
 .PP
Index: /pykota/trunk/man/dumpykota.1
===================================================================
--- /pykota/trunk/man/dumpykota.1 (revision 1721)
+++ /pykota/trunk/man/dumpykota.1 (revision 1724)
@@ -2,7 +2,7 @@
 .TH DUMPYKOTA "1" "September 2004" "C@LL - Conseil Internet & Logiciels Libres" "User Commands"
 .SH NAME
-dumpykota \- manual page for dumpykota 1.20alpha11_unofficial
+dumpykota \- manual page for dumpykota 1.20alpha12_unofficial
 .SH DESCRIPTION
-dumpykota v1.20alpha11_unofficial (c) 2003-2004 C@LL - Conseil Internet & Logiciels Libres
+dumpykota v1.20alpha12_unofficial (c) 2003-2004 C@LL - Conseil Internet & Logiciels Libres
 .PP
 Dumps PyKota database's content.
@@ -27,6 +27,6 @@
 - groups : dumps user groups.
 - printers : dump printers.
-- uquotas : dump user quotas.
-- gquotas : dump user groups quotas.
+- upquotas : dump user quotas.
+- gpquotas : dump user groups quotas.
 - payments : dumps user payments.
 - pmembers : dumps printer groups members.
Index: /pykota/trunk/man/pkhint.1
===================================================================
--- /pykota/trunk/man/pkhint.1 (revision 1722)
+++ /pykota/trunk/man/pkhint.1 (revision 1724)
@@ -2,7 +2,7 @@
 .TH PKHINT "1" "September 2004" "C@LL - Conseil Internet & Logiciels Libres" "User Commands"
 .SH NAME
-pkhint \- manual page for pkhint 1.20alpha11_unofficial
+pkhint \- manual page for pkhint 1.20alpha12_unofficial
 .SH DESCRIPTION
-pkhint v1.20alpha11_unofficial (c) 2003-2004 C@LL - Conseil Internet & Logiciels Libres
+pkhint v1.20alpha12_unofficial (c) 2003-2004 C@LL - Conseil Internet & Logiciels Libres
 A tool to give hints on what accounting method is best for each printer.
 .PP
Index: /pykota/trunk/man/repykota.1
===================================================================
--- /pykota/trunk/man/repykota.1 (revision 1722)
+++ /pykota/trunk/man/repykota.1 (revision 1724)
@@ -2,7 +2,7 @@
 .TH REPYKOTA "1" "September 2004" "C@LL - Conseil Internet & Logiciels Libres" "User Commands"
 .SH NAME
-repykota \- manual page for repykota 1.20alpha11_unofficial
+repykota \- manual page for repykota 1.20alpha12_unofficial
 .SH DESCRIPTION
-repykota v1.20alpha11_unofficial (c) 2003-2004 C@LL - Conseil Internet & Logiciels Libres
+repykota v1.20alpha12_unofficial (c) 2003-2004 C@LL - Conseil Internet & Logiciels Libres
 .PP
 Generates print quota reports.
Index: /pykota/trunk/man/warnpykota.1
===================================================================
--- /pykota/trunk/man/warnpykota.1 (revision 1722)
+++ /pykota/trunk/man/warnpykota.1 (revision 1724)
@@ -2,7 +2,7 @@
 .TH WARNPYKOTA "1" "September 2004" "C@LL - Conseil Internet & Logiciels Libres" "User Commands"
 .SH NAME
-warnpykota \- manual page for warnpykota 1.20alpha11_unofficial
+warnpykota \- manual page for warnpykota 1.20alpha12_unofficial
 .SH DESCRIPTION
-warnpykota v1.20alpha11_unofficial (c) 2003-2004 C@LL - Conseil Internet & Logiciels Libres
+warnpykota v1.20alpha12_unofficial (c) 2003-2004 C@LL - Conseil Internet & Logiciels Libres
 .PP
 Sends mail to users over print quota.