Index: pykota/trunk/pykota/accounters/software.py
===================================================================
--- pykota/trunk/pykota/accounters/software.py (revision 1687)
+++ pykota/trunk/pykota/accounters/software.py (revision 1743)
@@ -22,4 +22,7 @@
 #
 # $Log$
+# Revision 1.11  2004/09/24 21:19:48  jalet
+# Did a pass of PyChecker
+#
 # Revision 1.10  2004/08/31 23:29:53  jalet
 # Introduction of the new 'onaccountererror' configuration directive.
@@ -64,5 +67,4 @@
 #
 
-import sys
 import os
 import popen2
Index: pykota/trunk/pykota/accounters/hardware.py
===================================================================
--- pykota/trunk/pykota/accounters/hardware.py (revision 1739)
+++ pykota/trunk/pykota/accounters/hardware.py (revision 1743)
@@ -22,4 +22,7 @@
 #
 # $Log$
+# Revision 1.24  2004/09/24 21:19:48  jalet
+# Did a pass of PyChecker
+#
 # Revision 1.23  2004/09/23 19:18:12  jalet
 # Now loops when the external hardware accounter fails, until it returns a correct value
@@ -104,5 +107,4 @@
 #
 
-import sys
 import os
 import time
@@ -152,5 +154,5 @@
             tsp.close()
     
-        def handleAnswer(self, wholeMsg, transportAddr, req):
+        def handleAnswer(self, wholeMsg, notusedhere, req):
             """Decodes and handles the SNMP answer."""
             ver = alpha.protoVersions[alpha.protoVersionId1]
Index: pykota/trunk/pykota/storages/dbistorage.py
===================================================================
--- pykota/trunk/pykota/storages/dbistorage.py (revision 1327)
+++ pykota/trunk/pykota/storages/dbistorage.py (revision 1743)
@@ -22,4 +22,7 @@
 #
 # $Log$
+# Revision 1.2  2004/09/24 21:19:48  jalet
+# Did a pass of PyChecker
+#
 # Revision 1.1  2004/02/02 22:44:15  jalet
 # Preliminary work on Relationnal Database Independance via DB-API 2.0
@@ -43,5 +46,5 @@
 
 from pykota.storage import PyKotaStorageError,BaseStorage,StorageObject,StorageUser,StorageGroup,StoragePrinter,StorageJob,StorageLastJob,StorageUserPQuota,StorageGroupPQuota
-from pykota.storages.sqlstorage import SQLStorage
+from pykota.storages.sql import SQLStorage
 
 try :
Index: pykota/trunk/pykota/storage.py
===================================================================
--- pykota/trunk/pykota/storage.py (revision 1742)
+++ pykota/trunk/pykota/storage.py (revision 1743)
@@ -22,4 +22,7 @@
 #
 # $Log$
+# Revision 1.61  2004/09/24 21:19:48  jalet
+# Did a pass of PyChecker
+#
 # Revision 1.60  2004/09/24 20:21:50  jalet
 # Fixed pykotaAccountBalance object location during creation
@@ -547,5 +550,4 @@
     def getFromCache(self, cachetype, key) :
         """Tries to extract something from the cache."""
-        entry = None    # just to please pychecker
         if self.usecache :
             entry = self.caches[cachetype].get(key)
@@ -554,5 +556,5 @@
             else :    
                 self.tool.logdebug("Cache miss (%s->%s)" % (cachetype, key))
-        return entry    
+            return entry    
             
     def cacheEntry(self, cachetype, key, value) :        
Index: pykota/trunk/pykota/pdlanalyzer.py
===================================================================
--- pykota/trunk/pykota/pdlanalyzer.py (revision 1702)
+++ pykota/trunk/pykota/pdlanalyzer.py (revision 1743)
@@ -22,4 +22,7 @@
 #
 # $Log$
+# Revision 1.42  2004/09/24 21:19:48  jalet
+# Did a pass of PyChecker
+#
 # Revision 1.41  2004/09/04 14:18:55  jalet
 # Support for more laserjet models added.
@@ -194,17 +197,17 @@
             child.tochild.close()    
         except (IOError, OSError), msg :    
-            raise PDLAnalyzerError, "Problem during analysis of Binary PostScript document."
+            raise PDLAnalyzerError, "Problem during analysis of Binary PostScript document : %s" % msg
             
         pagecount = 0
         try :
             pagecount = int(child.fromchild.readline().strip())
-        except (IOError, OSError, AttributeError, ValueError) :
-            raise PDLAnalyzerError, "Problem during analysis of Binary PostScript document."
+        except (IOError, OSError, AttributeError, ValueError), msg :
+            raise PDLAnalyzerError, "Problem during analysis of Binary PostScript document : %s" % msg
         child.fromchild.close()
         
         try :
-            retcode = child.wait()
+            child.wait()
         except OSError, msg :    
-            raise PDLAnalyzerError, "Problem during analysis of Binary PostScript document."
+            raise PDLAnalyzerError, "Problem during analysis of Binary PostScript document : %s" % msg
         return pagecount * self.copies
         
@@ -335,5 +338,5 @@
                      # "*b" : "VW", # treated specially because it occurs very often
                    }  
-        pagecount = resets = ejects = backsides = startgfx = endgfx = strangegfx = 0
+        pagecount = resets = ejects = backsides = startgfx = endgfx = 0
         starb = ispcl3 = 0
         tag = None