Index: pykota/trunk/docs/edpykota.sgml
===================================================================
--- pykota/trunk/docs/edpykota.sgml (revision 1168)
+++ pykota/trunk/docs/edpykota.sgml (revision 1755)
@@ -16,5 +16,5 @@
       <listitem>
         <para>
-          Add printers ;
+          Add printers (it's preferable to use the <application>pkprinters</application> command for this though) ;
         </para>
       </listitem>
@@ -52,5 +52,10 @@
       <listitem>
         <para>
-          Choose the way you will limit printing : either by page quota or by account balance value.
+          Choose the way you will limit printing : either by page quota or by account balance value ;
+        </para>
+      </listitem>
+      <listitem>
+        <para>
+          Reset page counters.
         </para>
       </listitem>
@@ -63,4 +68,7 @@
 
 $Log$
+Revision 1.5  2004/09/28 17:45:31  jalet
+Added the --hardreset command line option to edpykota
+
 Revision 1.4  2003/10/14 20:26:53  jalet
 Better documentation.
Index: pykota/trunk/TODO
===================================================================
--- pykota/trunk/TODO (revision 1753)
+++ pykota/trunk/TODO (revision 1755)
@@ -25,7 +25,4 @@
           history, to be able to discover duplicate print
           jobs.
-          
-        - Add --hardreset command line option to
-          edpykota to also reset lifetime page counters to 0.
           
         - Maybe put "gracedelay" in the database.
Index: pykota/trunk/pykota/storage.py
===================================================================
--- pykota/trunk/pykota/storage.py (revision 1743)
+++ pykota/trunk/pykota/storage.py (revision 1755)
@@ -22,4 +22,7 @@
 #
 # $Log$
+# Revision 1.62  2004/09/28 17:45:31  jalet
+# Added the --hardreset command line option to edpykota
+#
 # Revision 1.61  2004/09/24 21:19:48  jalet
 # Did a pass of PyChecker
@@ -430,4 +433,9 @@
         self.parent.writeUserPQuotaPagesCounters(self, 0, int(self.LifePageCounter or 0))
         self.PageCounter = 0
+        
+    def hardreset(self) :    
+        """Resets actual and life time page counters to 0."""
+        self.parent.writeUserPQuotaPagesCounters(self, 0, 0)
+        self.PageCounter = self.LifePageCounter = 0
         
     def computeJobPrice(self, jobsize) :    
Index: pykota/trunk/bin/edpykota
===================================================================
--- pykota/trunk/bin/edpykota (revision 1584)
+++ pykota/trunk/bin/edpykota (revision 1755)
@@ -24,4 +24,7 @@
 #
 # $Log$
+# Revision 1.77  2004/09/28 17:45:31  jalet
+# Added the --hardreset command line option to edpykota
+#
 # Revision 1.76  2004/07/01 19:56:40  jalet
 # Better dispatching of error messages
@@ -334,7 +337,11 @@
   -n | --noquota       Doesn't set a quota but only does accounting.
   
-  -r | --reset         Resets the printed page counter for the user
-                       or group to zero. The life time page counter 
-                       is kept unchanged.
+  -r | --reset         Resets the actual page counter for the user
+                       or group to zero on the specified printers. 
+                       The life time page counter is kept unchanged.
+                       
+  -R | --hardreset     Resets the actual and life time page counters
+                       for the user or group to zero on the specified 
+                       printers. 
                        
   -l | --limitby l     Choose if the user/group is limited in printing                     
@@ -394,4 +401,6 @@
   well as every user whose name begins with 'jo'.
   Their life time page counter on each printer will be kept unchanged.
+  You can also reset the life time page counters by using the
+  --hardreset | -R command line option.
   
   $ edpykota --printer hpcolor --noquota jerome
@@ -622,4 +631,6 @@
                         if options["reset"] :
                             entrypquota.reset()
+                        elif options["hardreset"] :    
+                            entrypquota.hardreset()
                             
                         if balance :
@@ -660,6 +671,6 @@
                      "printer" : "*", \
                    }
-        short_options = "vhdc:l:b:i:naugrp:P:S:H:G:"
-        long_options = ["help", "version", "charge=", "delete", "limitby=", "balance=", "ingroups=", "noquota", "add", "users", "groups", "reset", "prototype=", "printer=", "softlimit=", "hardlimit=", "pgroups="]
+        short_options = "vhdc:l:b:i:naugrp:P:S:H:G:R"
+        long_options = ["help", "version", "charge=", "delete", "limitby=", "balance=", "ingroups=", "noquota", "add", "users", "groups", "reset", "hardreset", "prototype=", "printer=", "softlimit=", "hardlimit=", "pgroups="]
         
         # Initializes the command line tool
@@ -687,4 +698,5 @@
         options["charge"] = options["c"] or options["charge"]
         options["pgroups"] = options["G"] or options["pgroups"]
+        options["hardreset"] = options["R"] or options["hardreset"] 
         
         if options["help"] :
Index: pykota/trunk/man/edpykota.1
===================================================================
--- pykota/trunk/man/edpykota.1 (revision 1724)
+++ pykota/trunk/man/edpykota.1 (revision 1755)
@@ -2,7 +2,7 @@
 .TH EDPYKOTA "1" "September 2004" "C@LL - Conseil Internet & Logiciels Libres" "User Commands"
 .SH NAME
-edpykota \- manual page for edpykota 1.20alpha12_unofficial
+edpykota \- manual page for edpykota 1.20alpha17_unofficial
 .SH DESCRIPTION
-edpykota v1.20alpha12_unofficial (c) 2003-2004 C@LL - Conseil Internet & Logiciels Libres
+edpykota v1.20alpha17_unofficial (c) 2003-2004 C@LL - Conseil Internet & Logiciels Libres
 A Print Quota editor for PyKota.
 .PP
@@ -73,7 +73,12 @@
 .TP
 \fB\-r\fR | \fB\-\-reset\fR
-Resets the printed page counter for the user
-or group to zero. The life time page counter
-is kept unchanged.
+Resets the actual page counter for the user
+or group to zero on the specified printers.
+The life time page counter is kept unchanged.
+.TP
+\fB\-R\fR | \fB\-\-hardreset\fR
+Resets the actual and life time page counters
+for the user or group to zero on the specified
+printers.
 .TP
 \fB\-l\fR | \fB\-\-limitby\fR l
@@ -137,4 +142,6 @@
 well as every user whose name begins with 'jo'.
 Their life time page counter on each printer will be kept unchanged.
+You can also reset the life time page counters by using the
+\fB\-\-hardreset\fR | \fB\-R\fR command line option.
 .IP
 \f(CW$ edpykota --printer hpcolor --noquota jerome\fR
Index: pykota/trunk/NEWS
===================================================================
--- pykota/trunk/NEWS (revision 1751)
+++ pykota/trunk/NEWS (revision 1755)
@@ -24,4 +24,6 @@
     - 1.20alpha17 :
     
+        - Added --hardreset command line option to edpykota.
+        
         - Fixed problem with accented chars in title, filename
           or options and LDAP backend.