Index: /pykota/trunk/docs/repykota.sgml
===================================================================
--- /pykota/trunk/docs/repykota.sgml (revision 1287)
+++ /pykota/trunk/docs/repykota.sgml (revision 1783)
@@ -20,6 +20,6 @@
     
     <para>
-      <application>repykota</application> behaves differently when it is launched by the 
-      <literal>root</literal> user, compared to when it is launched by a normal user.
+      <application>repykota</application> behaves differently when it is launched by a
+      <application>PyKota</application> administrator, compared to when it is launched by a normal user.
     </para>  
     
@@ -152,4 +152,7 @@
 
 $Log$
+Revision 1.8  2004/10/06 10:03:16  jalet
+Improved documentation
+
 Revision 1.7  2004/01/12 23:10:35  jalet
 PyKota 1.16beta1 is finally out.
Index: /pykota/trunk/docs/warnpykota.sgml
===================================================================
--- /pykota/trunk/docs/warnpykota.sgml (revision 1101)
+++ /pykota/trunk/docs/warnpykota.sgml (revision 1783)
@@ -35,7 +35,7 @@
   
   <para>
-    When a non-root user launches this command, only him can receive a warning
+    When an user who is not a <application>PyKota</application> administrator launches this command, only him can receive a warning
     message. He can specify a printer name's filter to check his quota only
-    on specific printers. If a non-root users uses the <literal>--groups</literal> command line
+    on specific printers. If a normal user uses the <literal>--groups</literal> command line
     argument, then for each group he is a member of in the Quota Storage, each
     group member may receive a warning message. You can take care of this if this
@@ -45,5 +45,5 @@
   
   <para>
-    The <literal>root</literal> user can pass additionnal user or group names 
+    <application>PyKota</application> administrators can pass additionnal user or group names 
     (or wildcard filters) to only check the users or groups whose name matches.
   </para>  
@@ -76,4 +76,7 @@
 
 $Log$
+Revision 1.6  2004/10/06 10:03:16  jalet
+Improved documentation
+
 Revision 1.5  2003/07/25 13:10:58  jalet
 Improved documentation
Index: /pykota/trunk/docs/autopykota.sgml
===================================================================
--- /pykota/trunk/docs/autopykota.sgml (revision 1783)
+++ /pykota/trunk/docs/autopykota.sgml (revision 1783)
@@ -0,0 +1,55 @@
+<!-- $Id$ -->
+
+<chapter>
+  <title>Automate user account creation with autopykota</title>
+  <para>Last modified on $Date$</para>
+  
+  <para>
+    If you want to automate the users account and quota entries creation on first print,
+    you can do this easily with the <literal>policy: external( your command here )</literal>
+    directive in <filename>pykota.conf</filename>.
+    You just have to put your command of choice there.
+  </para>
+  
+  <para>
+    <application>autopykota</application> was designed to automatically set
+    an initial account balance value to newly added users, while taking
+    care of not resetting the balance value if the user already exists 
+    but doesn't have a quota entry on the current printer. 
+  </para>
+  
+  <para>
+    If you want to limit your users by page quota then you must not use
+    this command. Just use some form of the <application>edpykota</application>
+    command and it will work just fine. On the other hand, if you want
+    to limit your users by their account balance, this command was
+    made to ease your life : you don't have to design a complex shell
+    script to check if user already exists or have a quota entry on
+    the current printer before deciding if you have to set the initial
+    balance value or not : <application>autopykota</application> takes
+    care of all this automagically.
+  </para>
+  
+  <sect1>
+    <title>Reference</title>
+    <para>
+      <cmdsynopsis>
+        <command>autopykota</command>
+        <group choice="opt"><arg>-v</arg><arg>--version</arg></group>
+        <group choice="opt"><arg>-h</arg><arg>--help</arg></group>
+        <group choice="opt">
+          <arg>-i <replaceable>value</replaceable></arg>
+          <arg>--initbalance <replaceable>value</replaceable></arg>
+        </group>
+      </cmdsynopsis>
+    </para>
+  </sect1>
+</chapter>
+
+<!--
+
+$Log$
+Revision 1.1  2004/10/06 10:03:16  jalet
+Improved documentation
+
+-->
Index: /pykota/trunk/docs/installation.sgml
===================================================================
--- /pykota/trunk/docs/installation.sgml (revision 1612)
+++ /pykota/trunk/docs/installation.sgml (revision 1783)
@@ -29,7 +29,7 @@
     have to decompress and visit its archive, to do so just type the following commands :
     <screen>
-jerome@nordine:~$ tar -zxf pykota-1.19_official.tar.gz    
-jerome@nordine:~$ cd pykota-1.19_official
-jerome@nordine:~/pykota-1.19_official$
+jerome@nordine:~$ tar -zxf pykota-1.20_official.tar.gz    
+jerome@nordine:~$ cd pykota-1.20_official
+jerome@nordine:~/pykota-1.20_official$
     </screen>
   </para>
@@ -143,5 +143,7 @@
         A Quota Storage read-only user is also created under the name of <literal>pykotauser</literal>.
         This read-only user is used by <application>PyKota</application> to connect to the 
-        Quota Storage when a non-root user launches a pykota command. This prevents normal
+        Quota Storage when an user who is not a <application>PyKota</application> administrator 
+        <footnote><para>a <application>PyKota</application> administrator is an user who can read the <filename>/etc/pykota/pykotadmin.conf</filename> file.</para></footnote>
+        launches a pykota command. This prevents normal
         users from being able to modify their own, or other users', quota information.
         The database which will be created will be named <literal>pykota</literal> by default.
@@ -165,6 +167,6 @@
         From a command line interpreter (i.e. shell), type the following commands :
         <screen>
-jerome@nordine:~$ cd pykota-1.19_official/initscripts/postgresql
-jerome@nordine:~/pykota-1.19_official/initscripts$ psql -h localhost -U postgres template1
+jerome@nordine:~$ cd pykota-1.20_official/initscripts/postgresql
+jerome@nordine:~/pykota-1.20_official/initscripts$ psql -h localhost -U postgres template1
 Welcome to psql, the PostgreSQL interactive terminal.
 
@@ -197,5 +199,5 @@
 ALTER USER
 pykota=# \q
-jerome@nordine:~/pykota-1.19_official/initscripts/postgresql$
+jerome@nordine:~/pykota-1.20_official/initscripts/postgresql$
         </screen>
       </para>
@@ -585,5 +587,15 @@
 $ chmod 640 /etc/pykota/pykotadmin.conf      
       </screen>
-    </para>
+      
+      <warning>
+        <title>Warning</title>
+        <para>
+          All the users allowed to read the <filename>/etc/pykota/pykotadmin.conf</filename> 
+          are considered to be <application>PyKota</application> administrators. So be
+          careful with these files permissions.
+        </para>
+      </warning>
+    </para>
+    
     
     <para>
@@ -725,4 +737,7 @@
 
 $Log$
+Revision 1.28  2004/10/06 10:03:16  jalet
+Improved documentation
+
 Revision 1.27  2004/07/21 09:39:03  jalet
 LPRng documentation
Index: /pykota/trunk/docs/pykota.sgml
===================================================================
--- /pykota/trunk/docs/pykota.sgml (revision 1744)
+++ /pykota/trunk/docs/pykota.sgml (revision 1783)
@@ -12,4 +12,5 @@
   <!entity PYKOSD system "pykosd.sgml">
   <!entity DUMPYKOTA system "dumpykota.sgml">
+  <!entity AUTOPYKOTA system "autopykota.sgml">
   <!entity GNUGPL system "gnugpl.sgml">
 
@@ -112,4 +113,6 @@
 
   &EDPYKOTA;
+  
+  &AUTOPYKOTA;
     
   &REPYKOTA;
@@ -134,4 +137,7 @@
 
 $Log$
+Revision 1.15  2004/10/06 10:03:16  jalet
+Improved documentation
+
 Revision 1.14  2004/09/27 08:19:14  jalet
 Wrote some doc for dumpykota
Index: /pykota/trunk/docs/dumpykota.sgml
===================================================================
--- /pykota/trunk/docs/dumpykota.sgml (revision 1744)
+++ /pykota/trunk/docs/dumpykota.sgml (revision 1783)
@@ -14,8 +14,9 @@
   <para>
     <application>dumpykota</application> can export <application>PyKota</application>
-    datas in a number of formats. As of September 27th 2004, output formats are
-    comma separated values, semicolon separated values, and tab separated values.
-    More formats, different, are planned : <acronym>XML</acronym>, <acronym>SQL</acronym>,
-    and <acronym>LDIF</acronym> are planned, but are currently not implemented.
+    datas in a number of formats. The supported output formats are
+    comma separated values, semicolon separated values, tab separated values, and <acronym>XML</acronym>.
+    More formats may be added in the future. In particular, 
+    <acronym>SQL</acronym> and <acronym>LDIF</acronym> are planned, but 
+    are currently not implemented. 
   </para>
   
@@ -53,9 +54,5 @@
     <title>Warning</title>
     <para>
-      Contrary to the <application>repykota</application> command, <application>dumpykota</application>
-      doesn't currently limit which datas can be exported by normal users, so please take
-      care to not allow normal users to read the <filename>/etc/pykota/pykota.conf</filename>
-      file or to execute the <application>dumpykota</application> command if you don't
-      want to expose possibly sensitive datas.
+      Only <application>PyKota</application> administrators can dump PyKota's datas.
     </para>
   </warning>  
@@ -72,4 +69,8 @@
           <arg>--format <replaceable>outputformat</replaceable></arg>
         </group>
+        <group choice="opt">
+          <arg>-o <replaceable>filename</replaceable></arg>
+          <arg>--output <replaceable>filename</replaceable></arg>
+        </group>
         <group choice="req">
           <arg>-d <replaceable>datatype</replaceable></arg>
@@ -84,4 +85,7 @@
 
 $Log$
+Revision 1.2  2004/10/06 10:03:16  jalet
+Improved documentation
+
 Revision 1.1  2004/09/27 08:19:14  jalet
 Wrote some doc for dumpykota